unit FormulaTrans;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,basic_fns,types;

type
  arraytype=array[0..67] of string;
  TFormulaTrans = class(TComponent)
  private
    { Private declarations }
    FDegrees:Boolean;
    FPara:Boolean;
    FInstring:string;
    FOutstring:string;
    function Formint(str:string):string;
    function PutInMult(str:string):string;
    function replace_fn(str,func:string;where,i:integer):string;
    function minus(str:string):string;
    function separate_multiplied_functions(str:string):string;
    function changepower(str:string;i:integer):string;
    function implicit_sort(str:string):string;
    function ch_absolute(str:string):string;
    function derivative(str:string):string;
    function Factorial_Calc(str:string):string;
    function Factorial(x:integer):integer;
    procedure setinput;
  protected
    { Protected declarations }
  public
    { Public declarations }
    func_array:arraytype;
    internal:arraytype;
    constructor Create(AOwner:TComponent);override;
    property Outstring:string read FOutstring;
    procedure FormTrans;
  published
    { Published declarations }
    property Degrees:Boolean read FDegrees write FDegrees;
    property Para:Boolean read FPara write FPara;
    property Instring:string read FInstring write FInstring;

  end;

Type
   Keys=set of char;
var
  alphalower,alphaupper,numeric,operators,constantlist:Keys;

procedure Register;

implementation


procedure TFormulaTrans.FormTrans;
Begin
     FOutstring:=Formint(FInstring);
end;

function TFormulaTrans.Formint(str:string):string;
Var
   i:integer;
   whereisit:integer;
   funct:string;
Begin
   setinput;
   str:=LowerCase(str);
   str:=StringStripAll(str,' ');
   str:='('+str;
   str:=Minus(str);
   str:=str+')';
   str:=separate_multiplied_functions(str);
   If Instr(str,'=')>0 then str:=implicit_sort(str);


   If Instr(str,'''')>0 then str:=Derivative(str);
   If Instr(str,'!')>0 then str:=Factorial_Calc(str);
   for i :=0  to 65 do
       begin
            whereisit:=Instr(str,func_array[i]);
            funct:=func_array[i];
            If whereisit>0 then str:=replace_fn(str,funct,whereisit,i);
       end;
   Repeat
      If Instr(str,Chr(178))>0 then str:=changepower(str,178);
      If Instr(str,Chr(179))>0 then str:=changepower(str,179);
   Until (Instr(str,Chr(178))=0) and (Instr(str,Chr(179))=0);

   If Instr(str,'|')>0 then str:=ch_Absolute(str);
   str:=PutInMult(str);


   Formint:=str;

end;
function TFormulaTrans.Factorial_Calc(str:string):string;
Var
   count,count2,i,number:integer;
   num:string[255];
Begin
   count:=Instr(str,'!');
   count2:=count;
   While Instr('0123456789',copy(str,count-1,1))>0 do
      Dec(count);
   For i:=count To count2-1 do
       num:=num+copy(str,i,1);
   number:=Factorial(StrToInt(num));
   str:=StringStripAll(str,'!');
   str:=Leftstr(str,count-1);
   str:=str+IntTOStr(number);
   Factorial_Calc:=str;
end;

function TFormulaTrans.Factorial(x:integer):integer;
Var
  i,prod,temp:integer;
Begin
    If x<0 then temp:=1;
    prod:=1;
    If x=0 then temp:=1;
    try
    Begin
         For i:=1 To x do
             prod:=prod*i;
         end;
    except
          prod:=temp;
    end;
    Factorial:=prod;
end;

function TFormulaTrans.derivative(str:string):string;
Var
   dc:integer;
   first,last:string[255];
Begin
   dc:=Instr(str,'''');
   If dc>0 then
      Begin
          first:=Leftstr(str,dc-1);
          last:=Right(str,Length(str)-dc);
      end;
   derivative:='DIFF('+first+last+')';
end;

function TFormulaTrans.ch_absolute(str:string):string;
Var
   start:integer;
   first,last,temp:string;
Begin
   start:=Instr(str,'|');
   first:=Leftstr(str,start);
   last:=Right(str,Length(str)-start);
   first:=Leftstr(str,Length(first)-1);
   temp:=first+'ABS('+last;
   start:=Instr(temp,'|');
   first:=Leftstr(temp,start);
   last:=Right(temp,Length(temp)-start);
   first:=Leftstr(temp,Length(first)-1);
   temp:=first+')'+last;
   result:=temp;
end;

function TFormulaTrans.implicit_sort(str:string):string;
Var
   equals,exp:string[255];
Begin
   equals:=Right(str,Length(str)-Instr(str,'='));
   exp:=Leftstr(str,Instr(str,'=')-1);
   implicit_sort:=exp+'-'+equals;
end;

function TFormulaTrans.changepower(str:string;i:integer):string;
  Var
     power:integer;
     first,last,powerstr:string;
Begin
     power:=Instr(str,Chr(i));
     If power>0 then
        Begin
             first:=copy(str,1,power-1);
             last:=Right(str,Length(str)-power);
        end;
        If i=178 then powerstr:='^2';
        If i=179 then powerstr:='^3';
        changepower:=first+powerstr+last;
end;

function TFormulaTrans.minus(str:string):string;
Var
   where:integer;
Begin
     Repeat
           where:=Instr(str,'(-');
           If where>0 then str:=copy(str,1,where)+'0'+copy(str,where+1,Length(str)-where);
     Until Instr(str,'(-')=0;
     minus:=str;
end;


function TFormulaTrans.replace_fn(str,func:string;where,i:integer):string;
Var
   first,last:string;
   l_put:boolean;
   j,pp:integer;
Begin
     l_put:=False;
     j:=where-1;
     first:=copy(str,1,where-1);
     last:=Right(str,Length(str)-Length(func)-where+1);
     If (copy(last,1,1)<>'(') then
        Begin
           str:=first+internal[i]+'('+last;
           l_put:=True;
        end
     else
         str:=first+internal[i]+last;
     {endif}
     Repeat
         j:=j+1;
     Until (copy(str,j,1)[1] in alphaupper)=False;
     Repeat
         j:=j+1;
     Until ((copy(str,j,1)[1] in alphalower)=False) or (j>=Length(str));
     If l_put then
       Begin
        first:=copy(str,1,j-1);
        last:=Right(str,Length(str)-j+1);
        str:=first+')'+last;
       end;
     {endif}
     pp:=Instr(str,func);
     If pp>0 then str:=replace_fn(str,func,pp,i);
     replace_fn:=str;
end;

function TFormulaTrans.separate_multiplied_functions(str:string):string;
 Var
   p1,p2:char;
   i:integer;
   first,last:string;
Begin
   //In here look for instances where an 'x' is followed by another lowercase letter
   for i:=1 To length(str)-1 do
       Begin
            p1:=copy(str,i,1)[1];
            p2:=copy(str,i+1,1)[1];
            If (p1='x') and (p2 in alphalower) then
                Begin
                 first:=copy(str,1,i);
                 last:=Right(str,Length(str)-i);
                 If ((Right(first,1)[1] in operators)=False) and (last<>'') then str:=first+'*'+last;
                end;
       end;
   separate_multiplied_functions:=str;
end;

function TFormulaTrans.PutInMult(str:string):string;

Var
   i:integer;
   p1,p2:char;
   bung1in:Boolean;

   first,last:string;
Begin

   i:=1;
   bung1in:=False;
   Repeat
         p1:=copy(str,i,1)[1];
         p2:=copy(str,i+1,1)[1];
         If (p1 in alphalower) and (p2 in alphalower) then bung1in:=True;
         If (p1=')') and (p2='(') then bung1in:=True;
         If (p1 in alphalower) and (p2 in alphaupper) then bung1in:=True;
         If (p1 in alphaupper) and (p2 in alphaupper) then bung1in:=False;
         If (p1 in alphalower) and (p2=')') then bung1in:=False;
         If (p1 in alphalower) and (p2 in operators) then bung1in:=False;
         If (p1 in numeric) and (p2 in numeric) then bung1in:=False;
         If (p1 in numeric) and (p2 in alphaupper) then bung1in:=True;
         If (p1 in alphalower) and (p2='(') then bung1in:=True;
         If (p1=')') and (p2 in alphaupper) then bung1in:=True;
         If (p1 in numeric) and ((p2='e') or (p2='E')) then bung1in:=False;
         If (p1='e') then bung1in:=False;
         If p1='(' then bung1in:=False;
         If (p1 in operators) then bung1in:=False;
         If bung1in then
            Begin
                 first:=copy(str,1,i);
                 last:=Right(str,Length(str)-i);
                 If ((Right(first,1)[1] in operators)=False) and (last<>'') then str:=first+'*'+last;
            end;
         i:=i+1
   until (i>=Length(str));
   PutInMult:=str;
end;

procedure TFormulaTrans.setinput;
Begin
  func_array[0]:='asinh';  internal[0]:='ASINH';
  func_array[1]:='acosh';  internal[1]:='ACOSH';
  func_array[2]:='atanh';  internal[2]:='ATANH';
  func_array[3]:='asech';  internal[3]:='ASECH';
  func_array[4]:='acosech';  internal[4]:='ACOSECH';
  func_array[5]:='acoth';  internal[5]:='ACOTH';
  func_array[6]:='asin';  If FDegrees then internal[6]:='DEGASIN' else internal[6]:='ASIN';
  func_array[7]:='acos';  If FDegrees then internal[7]:='DEGACOS' else internal[7]:='ACOS';
  func_array[8]:='atan';  If FDegrees then internal[8]:='DEGATAN' else internal[8]:='ATAN';
  func_array[9]:='acot';  If FDegrees then internal[9]:='DEGACOT' else internal[9]:='ACOT';
  func_array[10]:='asec';  If FDegrees then internal[10]:='DEGASEC' else internal[10]:='ASEC';
  func_array[11]:='acosec';  If FDegrees then internal[11]:='DEGACOSEC' else internal[11]:='ACOSEC';
  func_array[12]:='sinh';  internal[12]:='SINHSQ';
  func_array[13]:='sinh';  internal[13]:='SINHCUBE';
  func_array[14]:='sinh';  internal[14]:='SINH';
  func_array[15]:='cosh';  internal[15]:='COSHSQ';
  func_array[16]:='cosh';  internal[16]:='COSHCUBE';
  func_array[17]:='cosh';  internal[17]:='COSH';
  func_array[18]:='cosech';  internal[18]:='COSECHSQ';
  func_array[19]:='cosech';  internal[19]:='COSECHCUBE';
  func_array[20]:='cosech';  internal[20]:='COSECH';
  func_array[21]:='sech';  internal[21]:='SECHSQ';
  func_array[22]:='sech';  internal[22]:='SECHCUBE';
  func_array[23]:='sech';  internal[23]:='SECH';
  func_array[24]:='tanh';  internal[24]:='TANHSQ';
  func_array[25]:='tanh';  internal[25]:='TANHCUBE';
  func_array[26]:='tanh';  internal[26]:='TANH';
  func_array[27]:='coth';  internal[27]:='COTHSQ';
  func_array[28]:='coth';  internal[28]:='COTHCUBE';
  func_array[29]:='coth';  internal[29]:='COTH';
  func_array[30]:='cosec';  If FDegrees then internal[30]:='COSECSQRAD' else internal[30]:='COSECSQ';
  func_array[31]:='cosec';  If FDegrees then internal[31]:='COSECCUBERAD' else internal[31]:='COSECCUBE';
  func_array[32]:='cosec';  If FDegrees then internal[32]:='COSECRAD' else internal[32]:='COSEC';
  func_array[33]:='sec';  If FDegrees then internal[33]:='SECSQRAD' else internal[33]:='SECSQ';
  func_array[34]:='sec';  If FDegrees then internal[34]:='SECCUBERAD' else internal[34]:='SECCUBE';
  func_array[35]:='cos';  If FDegrees then internal[35]:='COSSQRAD' else internal[35]:='COSSQ';
  func_array[36]:='cos';  If FDegrees then internal[36]:='COSCUBERAD' else internal[36]:='COSCUBE';
  func_array[37]:='sin';  If FDegrees then internal[37]:='SINSQRAD' else internal[37]:='SINSQ';
  func_array[38]:='sin';  If FDegrees then internal[38]:='SINCUBERAD' else internal[38]:='SINCUBE';
  func_array[39]:='cos';  If FDegrees then internal[39]:='COSRAD' else internal[39]:='COS';
  func_array[40]:='tan';  If FDegrees then internal[40]:='TANSQRAD' else internal[40]:='TANSQ';
  func_array[41]:='tan';  If FDegrees then internal[41]:='TANCUBERAD' else internal[41]:='TANCUBE';;
  func_array[42]:='tan';  If FDegrees then internal[42]:='TANRAD' else internal[42]:='TAN';
  func_array[43]:='sec';  If FDegrees then internal[43]:='SECRAD' else internal[43]:='SEC';
  func_array[44]:='cot';  If FDegrees then internal[44]:='COTSQRAD' else internal[44]:='COTSQ';
  func_array[45]:='cot';  If FDegrees then internal[45]:='COTCUBERAD' else internal[45]:='COTCUBE';
  func_array[46]:='cot';  If FDegrees then internal[46]:='COTRAD' else internal[46]:='COT';
  func_array[47]:='sin';  If FDegrees then internal[47]:='SINRAD' else internal[47]:='SIN';
  func_array[48]:='integ';  internal[48]:='INTEG';
  func_array[49]:='diff';  internal[49]:='DIFF';
  func_array[50]:='log';  internal[50]:='LOG';
  func_array[51]:='ln';  internal[51]:='LN';
  func_array[52]:='sqrt';  internal[52]:='SQRT';
  func_array[53]:='sqr';  internal[53]:='SQR';
  func_array[54]:='int';  internal[54]:='INT';
  func_array[55]:='exp';  internal[55]:='EXP';
  func_array[56]:='abs';  internal[56]:='ABS';
  func_array[57]:='inv';  internal[57]:='INV';
  func_array[58]:='blanc';  internal[58]:='BLANC';
  func_array[59]:='f';  internal[59]:='F';
  func_array[60]:='g';  internal[60]:='G';
  func_array[61]:='h';  internal[61]:='H';
  func_array[62]:='i';  internal[62]:='I';
  func_array[63]:='j';  internal[63]:='J';
  func_array[64]:='k';  internal[64]:='K';
  func_array[65]:='l';  internal[65]:='L';

  alphaLower:=['a'..'z','0'..'9','.','('];
   alphaupper:=['A'..'Z','('];
   operators:=['+','-','*','/','^','='];
   numeric:=['0'..'9','.'];
   constantlist:=['a'..'e','m'..'s','u'..'w','z'];
end;



constructor TFormulaTrans.Create(AOwner:TComponent);
begin
   inherited Create(AOwner);
   setinput;
end;



procedure Register;
begin
  RegisterComponents('Parsers', [TFormulaTrans]);
end;

end.
